import .connectives
import .leibniz
import .logic
axiom nat.nat : Type.
constant nat.O : nat.nat.
constant nat.filter_nat_type : forall (return : Type) , ((nat.nat) -> return) -> (nat.nat) -> return.
axiom nat.axiom_filter_nat_type_O : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , (((connectives.equal) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) )).
theorem nat.eq_filter_nat_type_O : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , (((leibniz.leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) )) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , ((((@connectives.equal_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) ))) (((@nat.axiom_filter_nat_type_O) (return_type)) (return)).
theorem nat.sym_eq_filter_nat_type_O : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , (((leibniz.leibniz) (return_type)) ((return) ((nat.O) ))) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) )) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , ((((@leibniz.sym_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) ))) (((@nat.eq_filter_nat_type_O) (return_type)) (return)).
constant nat.plus : (nat.nat) -> (nat.nat) -> nat.nat.
constant nat.plus_body : (nat.nat) -> (nat.nat) -> nat.nat.
axiom nat.axiom_plus : forall (n:nat.nat) , (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.plus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n)).
theorem nat.eq_plus : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.plus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n)) := fun (n : nat.nat) , ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n))) ((@nat.axiom_plus) (n)).
theorem nat.sym_eq_plus : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n))) (((nat.plus) ) (n)) := fun (n : nat.nat) , ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n))) ((@nat.eq_plus) (n)).
axiom nat.axiom_plus_body_O : (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) ((nat.O) ))) (fun (m : nat.nat) , m).
theorem nat.eq_plus_body_O : (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) ((nat.O) ))) (fun (m : nat.nat) , m) := ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) ((nat.O) ))) (fun (m : nat.nat) , m)) (@nat.axiom_plus_body_O).
theorem nat.sym_eq_plus_body_O : (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (fun (m : nat.nat) , m)) (((nat.plus_body) ) ((nat.O) )) := ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) ((nat.O) ))) (fun (m : nat.nat) , m)) (@nat.eq_plus_body_O).
theorem nat.plus_O_n : forall (n:nat.nat) , (((logic.eq_) (nat.nat)) (n)) ((((nat.plus) ) ((nat.O) )) (n)) := fun (n : nat.nat) , (((@nat.sym_eq_plus) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (n)) ((y) (n)))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (n)) ((y) (n)))) (((@nat.sym_eq_plus_body_O) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (n)) ((y) (n)))) (((@logic.refl_) (nat.nat)) (n)))).
